import datetime

from django.core.management.base import BaseCommand

from nonstop.models import RecurringStreamDiffusion, RecurringStreamOccurence
from emissions.models import Absence


class Command(BaseCommand):
    def handle(self, verbosity, **kwargs):
        for diffusion in RecurringStreamDiffusion.objects.filter(is_active=True):
            next_planned_date = diffusion.schedule.get_next_planned_date(since=datetime.datetime.now())
            try:
                occurence = RecurringStreamOccurence.objects.get(diffusion=diffusion, datetime=next_planned_date)
            except RecurringStreamOccurence.DoesNotExist:
                occurence = RecurringStreamOccurence(diffusion=diffusion, datetime=next_planned_date)
            if occurence.id and Absence.objects.filter(
                    emission=diffusion.schedule.emission, datetime=next_planned_date).exists():
                occurence.delete()
            elif not occurence.id:
                occurence.save()
